package me.mrletsplay.bmareas.command.area;

import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.ClickEvent;
import net.minecraft.text.HoverEvent;
import net.minecraft.text.HoverEvent.Action;
import net.minecraft.text.Text;
import net.minecraft.util.Formatting;

public class AreaCreateCommand extends FabricCommand {

	private static final HoverEvent CLICK_ME = new HoverEvent(Action.SHOW_TEXT, Text.literal("Click me!"));

	public AreaCreateCommand() {
		super("create");
		setDescription("See how to create your own area");
		setUsage("/area create");
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 0) {
			sendCommandInfo(event.getSender());
			return;
		}

		p.sendMessage(Text.literal("To create an area:"));

		p.sendMessage(Text.literal("1. ").formatted(Formatting.GOLD)
			.append(Text.literal("[Add]").formatted(Formatting.GREEN).styled(style -> style.withClickEvent(new ClickEvent(ClickEvent.Action.RUN_COMMAND, "/area addcorner")).withHoverEvent(CLICK_ME)))
			.append(Text.literal(" all corners of your area (or use ").formatted(Formatting.WHITE))
			.append(Text.literal("/area addcorner [offset]").formatted(Formatting.GRAY))
			.append(Text.literal(")").formatted(Formatting.WHITE)));

		p.sendMessage(Text.literal("2. ").formatted(Formatting.GOLD)
			.append(Text.literal("Use ").formatted(Formatting.WHITE))
			.append(Text.literal("/area done \"<name>\" [color (#000000)]").formatted(Formatting.GRAY))
			.append(Text.literal(" to create your area").formatted(Formatting.WHITE)));

		p.sendMessage(Text.literal(""));
		p.sendMessage(Text.literal("If you mess up, you can remove the last added corner using §7/area removecorner 1 §ror a specific corner using §7/area removecorner #index"));
	}

}
