package me.mrletsplay.bmareas.command.area;

import java.util.Collections;
import java.util.stream.Collectors;

import de.bluecolored.bluemap.api.markers.Marker;
import de.bluecolored.bluemap.api.markers.ShapeMarker;
import me.mrletsplay.bmareas.BMAreas;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import me.mrletsplay.mrcore.fabric.command.FabricCommandSender;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class AreaDeleteCommand extends FabricCommand {

	public AreaDeleteCommand() {
		super("delete");
		setDescription("Delete an area from the map");
		setUsage("/area delete <id>");

		setTabCompleter(event -> {
			FabricCommandSender sender = (FabricCommandSender) event.getSender();
			ServerPlayerEntity p = sender.asPlayer();
			if(p == null) return Collections.emptyList();

			if(event.getArgs().length == 0) {
				String prefix = p.getUuid().toString() + "_";
				return BMAreas.getAreaMarkerSet(p.getWorld()).getMarkers().entrySet().stream()
						.filter(en -> en.getKey().startsWith(prefix) && en.getValue() instanceof ShapeMarker)
						.map(en -> en.getKey().substring(prefix.length()))
						.collect(Collectors.toList());
			}

			return Collections.emptyList();
		});
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 1) {
			sendCommandInfo(event.getSender());
			return;
		}

		String markerID = p.getUuid().toString() + "_" + event.getArguments()[0];
		Marker m = BMAreas.getAreaMarkerSet(p.getWorld()).get(markerID);
		if(m == null || !(m instanceof ShapeMarker)) {
			p.sendMessage(Text.literal("§cThat area doesn't exist"));
			return;
		}

		BMAreas.getAreaMarkerSet(p.getWorld()).remove(markerID);
		BMAreas.saveMarkers();
		p.sendMessage(Text.literal("§aArea deleted successfully"));
	}

}
