package me.mrletsplay.bmareas.command.area;

import java.util.AbstractMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import de.bluecolored.bluemap.api.markers.ShapeMarker;
import me.mrletsplay.bmareas.BMAreas;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class AreaListCommand extends FabricCommand {

	public AreaListCommand() {
		super("list");
		setDescription("List all of your areas");
		setUsage("/area list");
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 0) {
			sendCommandInfo(event.getSender());
			return;
		}

		String prefix = p.getUuid().toString() + "_";
		List<Map.Entry<String, ShapeMarker>> markers = BMAreas.getAreaMarkerSet(p.getWorld()).getMarkers().entrySet().stream()
				.filter(en -> en.getKey().startsWith(prefix) && en.getValue() instanceof ShapeMarker)
				.map(en -> new AbstractMap.SimpleEntry<>(en.getKey(), (ShapeMarker) en.getValue()))
				.collect(Collectors.toList());

		if(markers.isEmpty()) {
			p.sendMessage(Text.literal("§cYou haven't created any areas yet"));
			return;
		}

		p.sendMessage(Text.literal("§aYour areas:"));
		for(Map.Entry<String, ShapeMarker> area : markers) {
			p.sendMessage(Text.literal(String.format("§6%s: §7%s", area.getKey().substring(prefix.length()), area.getValue().getLabel())));
		}
	}

}
