package me.mrletsplay.bmareas.command.area;

import java.util.List;

import me.mrletsplay.bmareas.BMAreas;
import me.mrletsplay.bmareas.command.Point;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class AreaListCornersCommand extends FabricCommand {

	public AreaListCornersCommand() {
		super("listcorners");
		setDescription("List all currently added corners");
		setUsage("/area listcorners");
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 0) {
			sendCommandInfo(event.getSender());
			return;
		}

		List<Point> points = BMAreas.points.get(p.getUuid());
		if(points == null) {
			p.sendMessage(Text.literal("§cYou haven't added any corners"));
			return;
		}

		p.sendMessage(Text.literal("§aCurrently added corners:"));
		for(int i = 0; i < points.size(); i++) {
			Point pt = points.get(i);
			p.sendMessage(Text.literal(String.format("§6#%s: (§7%s§6/§7%s§6)", i+1, pt.getX(), pt.getZ())));
		}
	}

}
