package me.mrletsplay.bmareas.command.marker;

import java.util.Arrays;
import java.util.Collections;

import com.flowpowered.math.vector.Vector2i;
import com.flowpowered.math.vector.Vector3d;

import de.bluecolored.bluemap.api.markers.POIMarker;
import me.mrletsplay.bmareas.BMAreas;
import me.mrletsplay.bmareas.command.Icon;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;
import net.minecraft.util.math.BlockPos;

public class MarkerAddCommand extends FabricCommand {

	public MarkerAddCommand() {
		super("add");
		setDescription("Add a marker to the map");
		setUsage("/area marker <name> <icon>");

		setTabCompleter(event -> {
			if(event.getArgs().length == 0) {
				return Arrays.asList("My fancy marker");
			}else if(event.getArgs().length == 1) {
//				List<String> icons = new ArrayList<>();
//				for(MarkerIcon i : BMAreas.markerAPI.getMarkerIcons()) icons.add(i.getMarkerIconID());
				return BMAreas.icons.stream()
					.map(i -> i.name())
					.toList();
			}

			return Collections.emptyList();
		});
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 2) {
			sendCommandInfo(event.getSender());
			return;
		}

		String name = event.getArguments()[0];
		Icon icon = BMAreas.icons.stream()
			.filter(i -> i.name().equals(event.getArguments()[1]))
			.findFirst().orElse(null);

		if(icon == null) {
			p.sendMessage(Text.literal("§cInvalid icon"));
			return;
		}

		BlockPos loc = p.getBlockPos();
		POIMarker poi = new POIMarker(name, new Vector3d(loc.getX(), loc.getY(), loc.getZ()), BMAreas.BLUEMAP_WEB_PATH.relativize(icon.path()).toString(), new Vector2i(icon.w() / 2, icon.h() / 2));
		BMAreas.getMarkerMarkerSet(p.getWorld()).put(p.getUuid().toString() + "_" + Long.toHexString(System.nanoTime()), poi);
		BMAreas.saveMarkers();
//		DynmapAreasMod.markerMarkerSet.createMarker(p.getUuid().toString() + "_" + Long.toHexString(System.nanoTime()), name, DynmapAreasMod.getWorldName(p.getWorld()), loc.getX() + 0.5, loc.getY(), loc.getZ() + 0.5, icon, true);
		p.sendMessage(Text.literal("§aMarker created"));
	}

}
